#!/bin/perl
 
if($#ARGV !=1 ){
	print "usage: tempmatch.pl paa_pvg_all.txt paa_pvg_part.txt \n";
	exit;
}

$all= $ARGV[0];
$part=$ARGV[1];


@MappingTable=();
#@MappingTable2=();
#$i=0;

open( ALLFILE,"<$all") or die;
open( PARTFILE, "<$part") or die ;
while(<PARTFILE>){

	$TheLine=$_;
	chomp($TheLine);
	
#	print "line=".$TheLine."\n";	
	@SplitLine=split(/\s/,$TheLine);
	$lexical=$SplitLine[0];
	$class=$SplitLine[$#SplitLine];
	$MappingTable{$lexical}=$class;	
#		$tag=substr($TheLine,length($lexical));
}

while(<ALLFILE>){
	$TheLine=$_;
	chomp($TheLine);
	
	@SplitLine=split(/\s/,$TheLine);
	$lexical=$SplitLine[0];
	$tag=substr($TheLine,length($SplitLine[0]));
	
	if(exists($MappingTable{$lexical}))
	{
		print $lexical."\t".$tag."\t".$MappingTable{$lexical}."\n";
		
	}else{
		print $lexical."\t".$tag."\n";
	}
}	
