#include <stdio.h>
#include "malib.h"
#include "wjhcode.h"
#include "global.h"
#include "trie.h"

char line[MAX_LINE];
char word[MAX_WORD];
char word2[MAX_WORD];

char mout[MAX_WORD];
char mout1[MAX_WORD];

int anal_dic=0;
main(argc, argv)
int argc;
char *argv[];
{
	int i,r,c,m;
	char *rword;

	TDBM *tf;
	char *p;

	m=argc;	
	strcpy(cfg_file,"/user2/home2/morph/mc_990921/ma.cfg");

	while (m>=2) {
		c=argc-m+1;

		if (!strcmp(argv[c],"--help")) {
			fprintf(stderr,"Usage : %s [-[ilntuU]] [@<cfgfile>]\n",argv[0]);
			fprintf(stderr,"Option - l : ġ\n");
			fprintf(stderr,"       - u : ̵Ͼ ó\n");
			fprintf(stderr,"       - U : ̵Ͼ ó   ǰ ĺ \n");
			fprintf(stderr,"       - i : ε̿  \n");
			fprintf(stderr,"       - t : top-down  \n");
			/* begin - added by yuntan 20000607 : м ɼ ߰ */
			fprintf(stderr,"       - n : м  \n");
			/* end - added by yuntan 20000607 */
			return;
		} else if (argv[c][0]=='-') {
			for (i=1;argv[c][i];i++) {
				if (argv[c][i]=='l') {
					if (longest == 0) longest=1;
					else fprintf(stderr,"Conflict option \'-l\'\n");
				} else if(argv[c][i]=='u') {
					if (unk_anal == 0) unk_anal=1;
					else fprintf(stderr,"Conflict option \'-u\'\n");
				} else if (argv[c][i]=='U') {
					if (unk_anal == 0&&unk_expand==0) unk_anal = unk_expand = 1;
					else fprintf(stderr,"Conflict option \'-u\'\n");
				} else if (argv[c][i]=='i') {
					if (indexing == 0 ) indexing=1;
					else fprintf(stderr,"Conflict option \'-i\'\n");
				} else if (argv[c][i]=='t') {
					if (top_down == 0 ) top_down=1;
					else fprintf(stderr,"Conflict option \'-t\'\n");
			/* begin - added by yuntan 20000607 : м ɼ ߰ */
				} else if (argv[c][i]=='n') {
					if (anal_dic == 0 ) anal_dic=1;
					else fprintf(stderr,"Conflict option \'-n\'\n");
			/* end - added by yuntan 20000607 */
				}
			}
		} else if (argv[c][0]=='@') 
			strcpy(cfg_file,argv[c]+1);


		/*
					 fprintf(stderr,"anal_dic=%d\n",anal_dic);
					 */
					 
		m--;
	}
	if (!strlen(cfg_file)) strcpy(cfg_file,"ma.cfg");
	/*
	if(argc>=2 && argv[1][0]=='-')
	for(i=1;argv[1][i] ; i++)
	{
		if(argv[1][i]=='l')
			longest=1;
		else if(argv[1][i]=='u')
			unk_anal=1;
		else if(argv[1][i]=='U')
		{
			unk_anal=1;
			unk_expand=1;
		}
		else if(argv[1][i]=='i')
			indexing=1;
		else if(argv[1][i]=='t')
			top_down=1;
	    if (argc>=3) 
			strcpy(cfg_file,argv[2]);
		else strcpy(cfg_file,"ma.cfg");
	} else if (argc>=2) {
		strcpy(cfg_file,argv[1]);
	} else {
		strcpy(cfg_file,"ma.cfg");
	}

	*/
	init_morph();

// edited by cwseo 
// tf=tdbm_open("/home/wjlee/study/ma990818/analyzed",'r');
	tf=tdbm_open(ana_file,'r');

//	fprintf(stderr,"%s\n%s\n%s\n%s\n%s\n",udict_file,sdict_file,cnt_file,tag_file,ana_file);
	while(gets(line) != NULL)
	{
		for(rword = front_word(word,line); rword != NULL; rword = front_word(word,rword)) 
		{
// BOS indicate the begining of a sentence
			if(strstr(word,"BOS") !=NULL) 
				puts("BOS");
// EOS indicate the end of a sentence
			else if (strstr(word,"EOS") != NULL)
				puts("EOS");
			else
			{
				if(!anal_dic && tf != NULL && tdbm_fetch(tf,word,mout)>0)
				{
// м  
					printf("@%s\n",word);
					for(p=front_token(mout1,mout,'^');
							p != NULL;
							p=front_token(mout1,p,'^'))
						printf("\t%s\n",mout1);
				}
				else
				{
					printf(" %s\n",word);
					coco_str(KS,TRI,word,word2);
					r=morph_anal(word2);
					print_result(r);
				}
			}
			puts("");

		}
	}
	close_morph();
	if(tf != NULL)
		tdbm_close(tf);
}
