#ifndef _global_h 

#define _global_h 1

//#include "config.h" /* for file position */

/* for some char type */
#define isspace2(c) ((c) == ' ')
#define isalpha2(c) ((c) >= 'a' && (c) <= 'z' || (c) >= 'A' && (c) <= 'Z')
#define isdigit2(c) ((c) >= '0' && (c) <= '9')
#define isalnum2(c) (isalpha2(c) || isdigit2(c) || (c) == '_' || (c) == '@') 

extern int han_type(char *str, char *result);
extern int ispunct2(char c);
extern int sscanff(char *buf, char *format, char *val);

/* for dict interface */
extern int init_stop();
extern int close_stop();

	/******
		by yuntan

		simti    κ̴ 
	******/
extern char stop_simti_fname[];
extern char simti_file_name[];

	/******
		 κ  
	******/

/* for tokenizing */
extern char *front_word(char *word, char *str);
extern char *front_tok(char *tok, char *str);
extern char *front_line(char *line, char *str);

/* for data exchange */
extern char hmbuf[];
extern int hmidx;
extern char stagbuf[];
extern int stagidx;
extern char numbuf[];
extern int numidx;
extern char gnbuf[];
extern int gnidx;
extern char cnbuf[];
extern int cnidx;
extern char delbuf[];
extern int delidx;

/* for eumjul information */
/* syllable.c */
extern char josa_set_1[];
extern char josa_set_2[];
extern char eomi_set_1[];
extern char eomi_set_2[];
extern char *front_tail_set[];
extern char *front_tail_set2[];
extern char front_tail_info1[];
extern char syl_joyongsa[];
extern char syl_nounchange[];
extern char *front_tail_info2[];
extern char *youngeon_eu_neu[];
extern char *youngeon_eul[];
extern char *youngeon_si[];
extern char syl_leotal[];
extern char syl_eu[];
extern char syl_eutal[];
extern char *syl_eutal_leu[];
extern char *syl_eutal_leu2[];
extern char syl_a[];
extern char syl_a2[];
extern char syl_eo[];
extern char *youngeon_neon[];
extern char syl_neon[];
extern char syl_leol[];
extern char syl_meom[];
extern char syl_beob[];
extern char syl_ahuh[];
extern char syl_ohwuh[];
extern char syl_ohwuh2[];
extern char syl_ee[];
extern char syl_ee2[];
extern char syl_oee[];
extern char syl_oee2[];
extern char syl_ae[];
extern char syl_leeneon[];
extern char syl_leo_bul[];
extern char syl_leu_bul[];
extern char syl_leu_bul2[];
extern char syl_yongeon_1[];
extern char syl_yongeon_2[] ;
extern char syl_yongeon_3[];
extern char syl_woo_bul[];
extern char syl_yeo_bul[];
extern char syl_d_bul[];
extern char syl_b_bul[];
extern char b_bul_org[];
extern char syl_s_bul[];
extern char syl_h_bul[];
extern char syl_front_tail[];
extern char syl_yongeon_change[];
extern char syl_yongeon_change2[];
extern char syl_yongeon_not_origin[];
extern char syl_nullleoljong_join_eomi[];
extern char syl_nulljong_join_eomi[];
extern char syl_jong_join_eomi[];
extern char syl_suffix[];
extern char syl_suffix[];
extern char syl_aux[];
extern char *adverb_concat[];

extern char *smember(char *set[], char *s);
extern char bindir[];

#endif

