#include <stdio.h>
#include <string.h>
#include "../share/global.h"
#include "../share/tags.h"
#include "../share/cnt.h"
#include "../share/cnt_not.h"
#include "malib.h"

#include "../share/trie.h"
#include "../share/wjhcode.h"
#include "../share/simti.h"

#include "exp3.c"

/* 
 * option  flag 
 */
int longest=0;
int unk_anal=0;
int unk_expand=0;
int indexing=0;
int top_down=0;
int etri_tagset=0;
/*
 * option flag   
 */

int IWG;
int UNK;
int UNK_SET;
int NUM_TAG;

MDIC *sys_dict;
MDIC *user_dict;
SIMTI *sf;

char *index_tag;		/* for indexing */

char cand[100000]; //euni

/*------------------------------ 
ξ Ǵ ǰ Ʈ
------------------------------*/
set_index_tag()
{
	index_tag=tset[tsetnum("index")];
}

/*---------------------------------------------------------------------- 
is_index(tnum)
	ξ Ǵ ǰ ˻ 
	ణ tool  Ƿ
	matools.c    ִ.
----------------------------------------------------------------------*/
int is_index(int tag)
{
	int i;

	for(i=0;index_tag[i];i++)
		if(index_tag[i]==tag)
			return YES;
	return NO;
}

#define TAG_TYPE_ALL         0
#define TAG_TYPE_VERBS       1
#define TAG_TYPE_NOUNS       2
#define TAG_TYPE_NPS         3
#define TAG_TYPE_ADJS        4
#define TAG_TYPE_NBNP        8
#define TAG_TYPE_JOSA        9
#define TAG_TYPE_YONGS       10
#define TAG_TYPE_EOMIES      11
#define TAG_TYPE_JP      	 12

unsigned char tag_types[20][100];
int set_tag_types()
{
	int i;
	//etri tag set option ־ 
	//kaist tag set tagset type 
	if(etri_tagset ==0){
	        strcpy(tag_types[TAG_TYPE_VERBS],tset[tsetnum("pv")]);
        	strcat(tag_types[TAG_TYPE_VERBS],tset[tsetnum("xsm")]);
	        i=strlen(tag_types[TAG_TYPE_VERBS]);
       		tag_types[TAG_TYPE_VERBS][i++]=tagnum("px");
   	        tag_types[TAG_TYPE_VERBS][i++]=0;

	        strcpy(tag_types[TAG_TYPE_NOUNS],tset[tsetnum("n")]);
        	strcpy(tag_types[TAG_TYPE_NPS],tset[tsetnum("np")]);
        	strcpy(tag_types[TAG_TYPE_ADJS],tset[tsetnum("pa")]);
        	strcpy(tag_types[TAG_TYPE_EOMIES],tset[tsetnum("e")]);

        	strcpy(tag_types[TAG_TYPE_YONGS],tset[tsetnum("p")]);
        	strcat(tag_types[TAG_TYPE_YONGS],tset[tsetnum("xsv")]);
        	strcat(tag_types[TAG_TYPE_YONGS],tset[tsetnum("xsm")]);
        	i=strlen(tag_types[TAG_TYPE_YONGS]);
        	tag_types[TAG_TYPE_YONGS][i++]=tagnum("ep");
        	tag_types[TAG_TYPE_YONGS][i++]=tagnum("jp");
        	tag_types[TAG_TYPE_YONGS][i++]=0;
		
		i=0;
        	tag_types[TAG_TYPE_JP][i++]=tagnum("jp");
        	tag_types[TAG_TYPE_JP][i++]=0;

		i=0;// 
        	tag_types[TAG_TYPE_NBNP][i++]=tagnum("nbn");
        	tag_types[TAG_TYPE_NBNP][i++]=tagnum("npd");
        	tag_types[TAG_TYPE_NBNP][i++]=tagnum("npp");
        	tag_types[TAG_TYPE_NBNP][i++]=0;

		i=0;
        	tag_types[TAG_TYPE_JOSA][i++]=tagnum("jxc");
        	tag_types[TAG_TYPE_JOSA][i++]=tagnum("jco");
        	tag_types[TAG_TYPE_JOSA][i++]=tagnum("jca");
        	tag_types[TAG_TYPE_JOSA][i++]=tagnum("jcm");
        	tag_types[TAG_TYPE_JOSA][i++]=tagnum("jcs");
        	tag_types[TAG_TYPE_JOSA][i++]=tagnum("jcc");
        	tag_types[TAG_TYPE_JOSA][i++]=0;
	}else{ // etri_tagset -e option ־
        
        	i=0;
        	tag_types[TAG_TYPE_VERBS][i++]=tagnum("pv");
        	tag_types[TAG_TYPE_VERBS][i++]=tagnum("xsm");
        	tag_types[TAG_TYPE_VERBS][i++]=tagnum("px");
        	tag_types[TAG_TYPE_VERBS][i++]=0;

       	 	strcpy(tag_types[TAG_TYPE_NOUNS],tset[tsetnum("n")]);
        	tag_types[TAG_TYPE_NPS][0]=tagnum("np");
        	tag_types[TAG_TYPE_ADJS][0]=tagnum("pa");
        	strcpy(tag_types[TAG_TYPE_EOMIES],tset[tsetnum("e")]);

        	strcpy(tag_types[TAG_TYPE_YONGS],tset[tsetnum("p")]);
        	i=strlen(tag_types[TAG_TYPE_YONGS]);
        	tag_types[TAG_TYPE_YONGS][i++]=tagnum("xsv");
        	tag_types[TAG_TYPE_YONGS][i++]=tagnum("xsm");
        	tag_types[TAG_TYPE_YONGS][i++]=tagnum("ep");
        	tag_types[TAG_TYPE_YONGS][i++]=tagnum("co");
        	tag_types[TAG_TYPE_YONGS][i++]=0;
		
		i=0;
        	tag_types[TAG_TYPE_JP][i++]=tagnum("co");
        	tag_types[TAG_TYPE_JP][i++]=0;

		i=0;// 
        	tag_types[TAG_TYPE_NBNP][i++]=tagnum("nb");
        	tag_types[TAG_TYPE_NBNP][i++]=tagnum("np");
        	tag_types[TAG_TYPE_NBNP][i++]=0;

		i=0;
        	tag_types[TAG_TYPE_JOSA][i++]=tagnum("jx");
        	tag_types[TAG_TYPE_JOSA][i++]=tagnum("jc");
        	tag_types[TAG_TYPE_JOSA][i++]=tagnum("jm");
        	tag_types[TAG_TYPE_JOSA][i++]=tagnum("jc");
        	tag_types[TAG_TYPE_JOSA][i++]=0;
	}
}

char cfg_file[1024];
char tag_file[1024];
char cnt_file[1024];
char sdict_file[1024];
char udict_file[1024];
char ana_file[1024];
char cnt_not_file[1024]; //by hyoueun

void rem_space(char *buf)
{
	char temp[1024];
	char *p;
	int s;
	s = 0;

	for (p=buf;p!=NULL && *p!='\0';p++)
		if (*p!=' ' &&   *p!='\r' && *p!='\t' && *p!='\n' ) {
			temp[s++]=*p;
		}

	temp[s]='\0';
	strcpy(buf,temp);
}

void
read_param(FILE *cfg)
{
	char buf[1024];

	/* default file kE name assginment */
	if(etri_tagset==0){
		strcpy(tag_file,"/home2/morph/m3.5/data/kE/tags_1.stf");
		strcpy(cnt_file,"/home2/morph/m3.5/data/kE/cnts_1.scf");
	 	strcpy(sdict_file,"/home2/morph/m3.5/data/kE/morph");
		strcpy(udict_file,"/home2/morph/m3.5/data/kE/user");
		strcpy(ana_file,"/home2/morph/m3.5/data/kE/analyzed");
		strcpy(cnt_not_file,"/home2/morph/m3.5/data/kE/cnt_not.txt"); //by hyoeun
	}else{ /* default file etri name assginment */
		strcpy(tag_file,"/home2/morph/m3.5/data/etri/tags_1.stf");
		strcpy(cnt_file,"/home2/morph/m3.5/data/etri/cnts_1.scf");
		strcpy(sdict_file,"/home2/morph/m3.5/data/etri/morph");
		strcpy(udict_file,"/home2/morph/m3.5/data/etri/user");
		strcpy(ana_file,"/home2/morph/m3.5/data/etri/analyzed");
	}

	if (cfg==NULL) return;
	/* reading the configuration file - ma.cfg */
	while (fgets(buf,1024,cfg)!=NULL) {
		rem_space(buf);
		if (!strncmp(buf,"sysdict=",8)) 
			strcpy(sdict_file,buf+8);
		else if (!strncmp(buf,"userdict=",9)) 
			strcpy(udict_file,buf+9);
		else if (!strncmp(buf,"cnt=",4)) 
			strcpy(cnt_file,buf+4);
		else if (!strncmp(buf,"tagset=",7))
			strcpy(tag_file,buf+7);
		else if (!strncmp(buf,"analyzed=",9))
			strcpy(ana_file,buf+9);
		else if (!strncmp(buf,"cnt_not=",8))
			strcpy(cnt_not_file,buf+8);
	}

//	fclose(cfg);
}
/*----------------------------------------------------------------------
initinalize
----------------------------------------------------------------------*/

init_morph()
{
/* Added by cwseo form here */
	FILE *cfg;

	cfg=fopen(cfg_file,"r");

	read_param(cfg);

	if (cfg != NULL) {

   	 	tagread(tag_file);
    	cntread(cnt_file);
		cnt_not_read(cnt_not_file); //by hyoeun
   		if(indexing)
			set_index_tag();
       
		set_tag_types();

        IWG=tagnum("iwg");
		UNK_SET=tsetnum("unk_set");
		if(unk_anal)
			UNK=tagnum("unk");
//		if(unk_expand)
	   	NUM_TAG=tagnum("nnc");
   		sys_dict=mdic_open(sdict_file,'r');
   		user_dict=mdic_open(udict_file,'r');
    
	    /* rule */
   		sf=simti_init();
		init_rule();
		
//		printf("tagfile: %s\n",tag_file);
//	    printf("cntfile: %s\n",cnt_file);
//		printf("sdicfile: %s\n",sdict_file);
//		printf("udicfile: %s\n",udict_file);
		fclose(cfg);
		return;
	}
	else {
		printf("not found ma.cfg\n");
	}
/*
	// "ma.cfg"    Ʒ ȴ.  η Ǿ ֱ  Ʒ ҽ ׳ ּóϿ.
    if(etri_tagset==0){
    	tagread("/home2/morph/m3.5/data/kE/tags_1.stf");
		cntread("/home2/morph/m3.5/data/kE/cnts_1.scf");
		cnt_not_read("/home2/morph/m3.5/data/kE/cnt_not.txt");
    	sys_dict=mdic_open("/home2/morph/m3.5/data/kE/morph",'r');
     	user_dict=mdic_open("/home2/morph/m3.5/data/kE/user",'r');
    }else{
    	tagread("/home2/morph/m3.5/data/etri/tags_1.stf");
		cntread("/home2/morph/m3.5/data/etri/cnts_1.scf");
		cnt_not_read("/home2/morph/m3.5/data/etri/cnt_not.txt");
    	sys_dict=mdic_open("/home2/morph/m3.5/data/etri/morph",'r');
     	user_dict=mdic_open("/home2/morph/m3.5/data/etri/user",'r');
    } 
	      
    if(indexing)
	set_index_tag();
        set_tag_types();

    IWG=tagnum("iwg");
	if(unk_anal)
		UNK=tagnum("unk");
	if(unk_expand)
		UNK_SET=tsetnum("unk_set");
    NUM_TAG=tagnum("nnc");
    

    sf=simti_init();
	init_rule();
*/
}

close_morph()
{
    mdic_close(sys_dict);
    if(user_dict !=NULL)
    mdic_close(user_dict);
    simti_close(sf);
}

/* segpos
   input string  : 
   0(iwg), 1(), 2(), 3(iwg), 4(), 5()

segment 
   input string  : 
   0(iwg), 1(), 2(), 3(iwg), 4(), 5()
   dict lookup result : x-nopath, .-path, else-dict_ok
   x
   	   .      	 x
   	   	  x
		  	 x
		                 .      
				        x
*/
#define MAX_MORPHEME_LINK	30

	
#define SP_STATE_N	0	    // ˻ϴ κ
#define SP_STATE_D	1		//ȭ  Ȯ 
#define SP_STATE_R	2		
#define SP_STATE_M	3		// Ģ ˻ϴ κ
#define SP_STATE_F	4	

typedef struct SegPos {		// segment position
    int key;				// one character
    int state;
    int next_pos; 			// next position link
    int sidx;
    int uidx;
    int nidx;
    int morph_count;
    int morpheme[MAX_MORPHEME_LINK];	// see MORPHEME
} SegPos;

#define MAX_SEGMENT 200  /*   ϸ .. ϴ.*/
SegPos	seg_pos[MAX_SEGMENT];
int	seg_pos_end=0;

typedef struct MORPHEME {	// ¼ м chart 
    int tag;				// tag of morphme
    int phone;
    int next_pos;			// next segment position
    int next_tag_type;			// ǰ 
    int state;				// processing state
    int cnt_count;	
    int connection[MAX_MORPHEME_LINK];	// connected morpheme
    char str[MAX_SEGMENT];
} MORPHEME;


/*----------------------------------------------------------------------
lattice style chart
----------------------------------------------------------------------*/
/**
  * ׽Ʈ  SegPosü printfϴ Լ 
 */
print_segment_pos()
{
	int i;
	fprintf(stderr,"seg_pos_end=%d\n",seg_pos_end);
	for(i=1;i<seg_pos_end;i++)
	{
		fprintf(stderr,"seg_pos[%d].key=%d link=%d\n",
			i,seg_pos[i].key,seg_pos[i].next_pos);
	}
}

MORPHEME mchart[1000];
int	mchart_end=0;
/**
  * ׽Ʈ  mchart printfϴ Լ 
 */
print_morpheme_all()
{
	int i,j;
	char tmpstr[1024];
	printf("m_chart_end=%d\n",mchart_end);
	for(i=0;i<mchart_end;i++)
	{
	    printf("chart_id=%d, ",i);
        printf("%s/%s.%s next=%d next_tag_ty=%s mstate=%d, ", coco_str(TRI,KS,mchart[i].str, tmpstr),
		    tagname[mchart[i].tag],
		    irrname[mchart[i].phone],
		    seg_pos[mchart[i].next_pos].key,
		    tagname[mchart[i].next_tag_type],
		    mchart[i].state);
        printf("conexion=");
        for(j=0;j< mchart[i].cnt_count;j++)
		    printf("%d, ",mchart[i].connection[j]);
        printf("\n");
	}
}
/**
  * parameter  ο morpheme  Ҹ mchart ߰ϴ Լ
  * @param tag		˻   ϳμ tag.
  * @param phone	˻   ϳμ ڼ
  * @param next_pos		˻   ϳμ   index
  * @param next_tag_type	˻   ϳμ  ± type
 
 */
int new_chart(int tag, int phone, int next_pos, int next_tag_type)	// check
{
	mchart[mchart_end].tag=tag;
	mchart[mchart_end].phone=phone;
	mchart[mchart_end].next_pos=next_pos;
	mchart[mchart_end].next_tag_type=next_tag_type;
	mchart[mchart_end].state=INCOMPLETE;	//  м ʿ
	mchart[mchart_end].cnt_count=0;
	return mchart_end++;
}

/** 
  * mchart üο ־  ±,   شϴ Ұ ִ ˻ϴ Լ
  * @param morpheme ˻  ¼ м chart  迭
  * @param count	mchartü ο ˻   Ÿ .
  * @param mtag		˻   ϳμ tag.
  * @param phone	˻   ϳμ ڼ
  * @param next		˻   ϳμ   index
  * @param btag		˻   ϳμ  ± type
  * @param str		˻   ϳμ ش ڿ.
  * @return			1 쿡 ˻  , else 
 */
exist_chart(int morpheme[],int count, int mtag, int phone, int next, int btag, char *str)
{
	int i;
	for(i=0;i<count;i++)
	{
		if( mchart[morpheme[i]].tag==mtag &&
			mchart[morpheme[i]].phone==phone &&
			mchart[morpheme[i]].next_pos==next &&
			mchart[morpheme[i]].next_tag_type==btag &&
			strcmp(mchart[morpheme[i]].str,str)==0)
				return 1;
	}
	return 0;
}

/** 
  * SegPosü ־ index     index ȯϴ Լ̴. 
  * @param x    ̵Ǵ  index
  * return		x   index ȯ. 
 */
int next_pos(int x)
{
    return seg_pos[x].next_pos;
}

/*----------------------------------------------------------------------*/


/** 
  * SegPos ü ο Ҹ ߰ϴ Լ̴. 
  * @param key ο  key
  * return     ο  index ȯѴ. 
 */
int new_segment_pos(int key)	// check
{
	seg_pos[seg_pos_end].key=key;
	seg_pos[seg_pos_end].state=SP_STATE_N;
	seg_pos[seg_pos_end].morph_count=0;
	seg_pos[seg_pos_end].next_pos=0;
	seg_pos[seg_pos_end].sidx=0;
	seg_pos[seg_pos_end].uidx=0;
	seg_pos[seg_pos_end].nidx=0;
	return seg_pos_end++;
}

/** 
  * SegPos ü linkage  Լ̴.  (old_sp --> new_sp)
  * @param old_sp   link  index
  * @param new_sp	link ĳ index
 */
int seg_pos_link(int old_sp,int new_sp)		// check
{
    seg_pos[old_sp].next_pos=new_sp;
    return old_sp;
}


/** 
  * ¼Һм   data  initϴ Լ,  (ַ index, seg_pos ü ʱȭ Ų, 
  * ־ ڿ(κмҰ)  ʱȭ Ѵ. 
  * @param str  м ڿ
 */
init_segment(char *str)		// checked
{
	int new_sp,old_sp;
	int i=0;
	char rev[MAX_SEGMENT];

    simti_clean(sf);

	seg_pos_end=0;
	old_sp=new_segment_pos(0);
	seg_pos[old_sp].state=SP_STATE_M;
	while(*str)
	{
		new_sp=new_segment_pos(*str);
		seg_pos_link(old_sp,new_sp);
		old_sp=new_sp;
		rev_str(str,rev);

		simti_insert(sf,rev,new_sp);
		str++;
	}
	/* ܾ  Ÿ ġμ  */
	seg_pos_link(old_sp,0);
}


/** 
  * ¼Һм ̴ chart ü ʱȭϴ Լ.
 */
init_chart()	//check
{
	mchart_end=0;
	seg_pos[0].morpheme[seg_pos[0].morph_count++]=mchart_end;
	mchart[mchart_end].tag = IWG;
	mchart[mchart_end].phone=0;
	mchart[mchart_end].next_pos = 1;
	mchart[mchart_end].next_tag_type=0;
	mchart[mchart_end].state=SUCCESS;	//   ǹ̷μ
	mchart[mchart_end].cnt_count=0;
	mchart[mchart_end].str[0]=0;
	mchart_end++;
}



int phone_type_check(int ptype, int phone)
{
	if(ptype==0)
		return 1;
	return ptype==phone;
}



/** 
  * tag  validity ˻ϴ Լ 
  * @param ttype   tag class Ÿ.  defineǾ  (ex. josa, verb.)  0  all tag ǹѴ. 
  * @param tag     ˻ tag
  * return 1  success ǹѴ. 
 */
int tag_type_check(int ttype, int tag)
{
	int i;
	if(ttype==0)
		return 1;
	for(i=0;tag_types[ttype][i];i++)
		if(tag_types[ttype][i]==tag)
			return 1;
	return 0;
}


/** 
  * ־ ڿ reverse ڿ SIMTI ü(instance name = sf) insertϴ Լ  
  * @param str  ڿ
 */
int alt_segment(char *str)
{
	int old_sp=0;
	int new_sp=0;
	int match;
	int len;
	int to;
	char *p;
	char rev[MAX_SEGMENT];

	len=strlen(str);
	rev_str(str,rev); //global.c rev_str function
	match=simti_search(sf,rev); //match Ǵ revڿ   
	rev[match]=0;
	to=simti_fetch(sf,rev);

	p=str;
	while(*p)
	{
		if(len<=match)
			break;
		new_sp=new_segment_pos(*p);
		if(old_sp)
			seg_pos_link(old_sp,new_sp);
		old_sp=new_sp;
		rev_str(p,rev);
		simti_insert(sf,rev,new_sp);
		p++; len--;
	}
	if(old_sp)
		seg_pos_link(old_sp,to);
	rev_str(str,rev);
	return simti_fetch(sf,rev);
}

phone_change(int from, char *front, char *back, int ftag, int btag, int phone)
{
	INFO ibuff[20];
	int isize;
	int i,x,y;
	int next;
	int nc_idx;

	// 1. պκ  ˻
	isize=mdic_fetch(sys_dict,front,ibuff);
	for(i=0;i<isize;i++)
	{
		//2. պκ ǰ 
		x=tag_type_check(ftag,ibuff[i].mtag);
		//3. պκ  
		y=phone_type_check(phone,ibuff[i].phone);

		if(x&&y)
		{
			next=alt_segment(back);
							//޺κ ǰ 
			/* next ٸ ٸ  ϴµ... */
			if(!exist_chart(seg_pos[from].morpheme,seg_pos[from].morph_count,ibuff[i].mtag,ibuff[i].phone,next,btag,front))
			{
				int x;
				
			    nc_idx= new_chart(ibuff[i].mtag,ibuff[i].phone,next,btag);
			    strcpy(mchart[nc_idx].str,front);
			    //prntf("phone chang -->\n");
		        //print_morpheme_all();
				
			/*
			for(x=0;x<seg_pos[from].morph_count;x++)
				if(seg_pos[from].morpheme[x]==nc_idx)
					break;
			if(x==seg_pos[from].morph_count)
			*/

			seg_pos[from].morpheme[seg_pos[from].morph_count++]=nc_idx;
		    }
		    else{
		        printf("exit chart \n");
		    }
		}
	}
}



#define CNTLevel 0



/**
  *  Ȯϴ Լ 
  * @param chart1	connection   . 
  * @param chart2	connection   .
  * return value , м  final 迭 Ѵ.
 */
int Con_Check(int chart1, int chart2) // check
{
/*	輱 . 2000.9.25
	ո    ġ,
	1   ϴ κ ߰ߴ.
*/

    int t1,t2;
    int l1,l2;
    t1=mchart[chart1].tag;
    t2=mchart[chart2].tag;
    l1=strlen(mchart[chart1].str);
    l2=strlen(mchart[chart2].str);

//	1      . Ʒ
    if ((!(strncmp(tagname[t1],"nc",2)) ||
			tagname[t1][0]=='f') && 
    	(tagname[t2][0]=='n'))
	{ 
		if (tagname[t2][1]=='q')
			return 0; 
		else if ((l1<4 || l2<4) )
			return 0;
	}
//  
    return (ctable[t1][t2/8] & (1 << (t2%8))) 
	&& tag_type_check(mchart[chart1].next_tag_type,t2);
//    return (CTBL[t1][t2] > CNTLevel);

}

// by hyoeun
// connection ϴ rule 
/**
  *  ش ʴ  ϴ rule Ų Լ 
  * @param chart1	connection   . 
  * @param chart2	connection   . 
  * return 1̸ invalid connection ִ . 0̸ invalid con ٴ  ǹ 
 */
int Con_Not_Check(int chart1,int chart2)
{
    int i;	
    int t1,t2;
   // char *any="*";
    char *s1,*s2;
    char star[100];
    char temp[100];
    t1=mchart[chart1].tag;
    t2=mchart[chart2].tag;
    s1=mchart[chart1].str;
    s2=mchart[chart2].str;
    coco_str(KS,TRI,"*",star);
    for(i=0;i<cnt_not_num; i++)
    {
	    //strcpy(temp,cnottable_tag[i][1]);
	    //printf("%s\n",temp);
	   //Ѵ "*"ϰ cnottable_mp ʿ  
	    // cnottagle_mp  * ɼ ְ, cnottable_tag tag,tag_set ɼ 
    	    if (!((!strncmp(tagname[t1],cnottable_tag[i][0],strlen(cnottable_tag[i][0]))) && (!strncmp(tagname[t2],cnottable_tag[i][1],strlen(cnottable_tag[i][1])))) ){
		    	continue;
	   }
	   // if (t1!=cnottable_tag[i][0]||t2!=cnottable_tag[i][1]) continue;

	    if ( ((!strcmp(cnottable_mp[i][0],star) || !strcmp(cnottable_mp[i][0],s1)) && 
		(!strcmp(cnottable_mp[i][1],star) || !strcmp(cnottable_mp[i][1],s2))) ){

		return 1;
	   }
    }
   // printf("con_not-no match!!!!\n");
    return 0; //matchǴ  ϳ 
}
    
				   
		    
			    
    

/* ڸ ãƳ  丶Ÿ */
unsigned char num_automata[13][7]={
/*      ACC, +, -, ., ,, n, etc.     */
        { 0, 0, 0, 0, 0, 0, 0}, /* 0 */
        { 0, 9, 9, 0, 0, 2, 0}, /* 1 */
        { 1, 0, 0,11, 5, 3, 0}, /* 2 */
        { 1, 0, 0,11, 5, 4, 0}, /* 3 */
        { 1, 0, 0,11, 5,10, 0}, /* 4 */
        { 0, 0, 0, 0, 0, 6, 0}, /* 5 */
        { 0, 0, 0, 0, 0, 7, 0}, /* 6 */
        { 0, 0, 0, 0, 0, 8, 0}, /* 7 */
        { 1, 0, 0, 0, 5, 0, 0}, /* 8 */
        { 0, 0, 0, 0, 0,10, 0}, /* 9 */
        { 1, 0, 0,11, 0,10, 0}, /* 10 */
        { 1, 0, 0, 0, 0,12, 0}, /* 11 */
        { 1, 0, 0, 0, 0,12, 0}  /* 12 */
};
/**
  * ڸ ã 丶Ÿ ˻ϴ Լ 
 */
int ndic_node_look(int c, int nidx)
{
        int inp;
	switch(c)
	{
		case '+' : inp=1; break;
		case '-' : inp=2; break;
		case '.' : inp=3; break;
		case ',' : inp=4; break;
		default  : 
			if(isdigit(c))
				inp=5; 
			else
				inp=6;
	}
	return num_automata[nidx][inp];
}

char mstring[MAX_SEGMENT];
char mstring2[MAX_SEGMENT];
int seg_path[MAX_SEGMENT];

/**
  * ¼ м ٽ Լ  ˻ ȭȮ, ̵Ͼ ó ձĢ˻ 4ܰ踦 ģ.
  * @param chart_id	м  chart index, ( 0 ҷ ó Ѵ. )  
  * @param ttype	¼Һм tag  Ÿ. (ex. Ʈ ±׼, ī̽Ʈ ±׼µ)  
 */
int anal_chart(int chart_id, int ttype)
{
    int from, to;
    int i,j,x,y;
    int mp;
    int c;
    int nc_idx;
    TNODE *tnode;
    INFO *inode;
    IDX info;
    int isize;
    IDX sidx=1;
    IDX uidx=1;
    IDX nidx=1;
    char k[1000];
    
     
    from=mchart[chart_id].next_pos;
  // printf("S****\n");
    //print_morpheme(chart_id);
    //printf("E****\n\n");
    switch(seg_pos[from].state)			// N,D,R,M,F
    {
	default :
	    return 0;
/*#  ˻ϴ κ */
	case SP_STATE_N :
	    i=0;
	  
		// Էµ   ּҴ ¼ҷ ϳ ϸ鼭  sequential տ   ˻ ϴ κ. 
		// 
		for(to=from;to;to=next_pos(to))	
	    {
			c=seg_pos[to].key; 
		//fprintf(stdout,"c=%d\n", to);
			if(sidx)
				sidx=mdic_node_look(sys_dict,c,sidx);
			if(user_dict != NULL && uidx)
				uidx=mdic_node_look(user_dict,c,uidx);
			/*#  ã  丶Ÿ κ */
			if(nidx)
				nidx=ndic_node_look(c,nidx);
			seg_pos[to].sidx=sidx;
			seg_pos[to].uidx=uidx;
			seg_pos[to].nidx=nidx;
			mstring[i]=c;
			mstring[i+1]=0;
			//fprintf(stdout,"sidx =%d, uidx=%d, nidx=%d, mstring=%s\n",sidx,uidx,nidx,coco_str(TRI,KS,mstring,k));
			seg_path[i++]=to;
	    }
	   	
	    nidx=0;
	    mstring[i]=0;
	    strcpy(mstring2,mstring);
	    
	    //fprintf(stdout,"mstring=%s\n",coco_str(TRI,KS,mstring,k));
	    //fprintf(stdout,"mstring2=%s\n",coco_str(TRI,KS,mstring2,k));
	    
		//   for statement Ǿ  յ 
		//      ˻Ͽ ¼ м  Ѵ. 
  	    for(;i>0;i--)			
	    {
			mstring[i]=0;
			to=seg_path[i-1];
			
			// 1. System dictionary ˻Ͽ Ѵ. 
			if(seg_pos[to].sidx)
			{
				tnode = mdic_node(sys_dict,seg_pos[to].sidx);
				info=tnode->info_idx;
				isize=tnode->info_size;

				//fprintf(stdout,"%d=======\n", isize);
				for(j=0;j<isize;j++)
				{
					inode=mdic_info(sys_dict,info+j);
					nc_idx= new_chart(inode->mtag, inode->phone, next_pos(to),0);
					strcpy(mchart[nc_idx].str,mstring);
					seg_pos[from].morpheme[seg_pos[from].morph_count++]=nc_idx;
				}
			}
			// 2. User dictionary ˻Ͽ Ѵ. 
			if(user_dict != NULL && seg_pos[to].uidx)
			{
				tnode = mdic_node(user_dict,seg_pos[to].uidx);
				info=tnode->info_idx;
				isize=tnode->info_size;
				for(j=0;j<isize;j++)
				{
					inode=mdic_info(user_dict,info+j);
					nc_idx= new_chart(inode->mtag, inode->phone,next_pos(to),0);
					strcpy(mchart[nc_idx].str,mstring);
					seg_pos[from].morpheme[seg_pos[from].morph_count++]=nc_idx;
				}
			}
			// 3.   dictionary ˻Ͽ Ѵ. 
			if(nidx==0 && seg_pos[to].nidx)
			{
				if(num_automata[seg_pos[to].nidx][0])
				{
					nc_idx= new_chart(NUM_TAG, 0, next_pos(to),0);
					strcpy(mchart[nc_idx].str,mstring);
				
					seg_pos[from].morpheme[seg_pos[from].morph_count++]=nc_idx;
					nidx=seg_pos[to].nidx;
				}
				else
					nidx=0;
			}
	    }
	    seg_pos[from].state=SP_STATE_D;
/* # ȭ  Ȯ */	
	case SP_STATE_D :	
	
		
		prule(from, mchart[chart_id].str, mstring2);

	    seg_pos[from].state=SP_STATE_R;
	    	
				
	case SP_STATE_R :
	  
			/* ̵Ͼ óϴ  ⼭  ȴ.
			 *  ȣ ִٸ ⿡ ۵ȴ.
			 * M(ϴ) --> D()+M(ϴ)
			 */
	    x=0;
	    for(i=0;i<seg_pos[from].morph_count;i++)
	    {
			mp=seg_pos[from].morpheme[i];

			/* ϴ' ȣ  ؼ...
			 * ̺κ Ϻ   ٰŴ.
			 */
			if(tag_type_check(ttype,mchart[mp].tag) == 0)
				continue; 

			/* ̺κ 'ٺ'   '' ߺ  Ǵ 
			 * ´.
			 * ٺ+
			 *     ++
			 */
			if(mchart[mp].state==INCOMPLETE)
			{
				y=anal_chart(mp,mchart[mp].next_tag_type);
				x+=y;
				if(y)
					mchart[mp].state=SUCCESS;
				else
					mchart[mp].state=FAIL;
			}
			else
				x+=mchart[mp].cnt_count;
		}
		if(x==0)
		{
			// ' 
			if(!ttype) // κ ǰ縸   ߿ ٽؾ Ѵ.
				seg_pos[from].state=SP_STATE_F;
			return 0;
		}
		if(!ttype) // κ ǰ縸   ߿ ٽؾ Ѵ.
			seg_pos[from].state=SP_STATE_M;

/* #  Ģ ˻ϴ κ */			
	case SP_STATE_M :
	    for(i=0;i<seg_pos[from].morph_count;i++)
	    {
			mp=seg_pos[from].morpheme[i];
			//	    chart mp  success ˻ؾߵ
			if(mchart[mp].state==SUCCESS && Con_Check(chart_id,mp) && !Con_Not_Check(chart_id,mp))
			{
				mchart[chart_id].connection[mchart[chart_id].cnt_count++]=mp;
				if(longest)
					break;
			}
	    }
    }
 
    return mchart[chart_id].cnt_count;
}



/**
  * "-u" option   Ǵ Լ
  *  seg_pos   ڼҸ  unk ± ο chart ߰ϰ,
  *  anal_chart(0,0) ȣѴ. 
  ex) 
   /unk+/jcc	--	簡 ִ  ؾѴ.
   /unk+/jcs	--
   /unk
 */
int anal_chart_unk()
{
	int i,j;
	int nc_idx;

	for(i=1;i;i=next_pos(i))
	{
	    mstring[i-1]=seg_pos[i].key;
	    if(is_tri_co(seg_pos[i].key))
		continue;

		mstring[i]=0;
		if(unk_expand)
		{
			for(j=0;tset[UNK_SET][j];j++)
			{
				nc_idx = new_chart(tset[UNK_SET][j],0,next_pos(i),0);
				strcpy(mchart[nc_idx].str,mstring);
				//printf("unk-expand o -->\n");
		        //print_morpheme_all();
				seg_pos[1].morpheme[seg_pos[1].morph_count++]=nc_idx;
				seg_pos[1].state=SP_STATE_R;
			}
		}
		else
		{
			nc_idx = new_chart(UNK,0,next_pos(i),0);
			strcpy(mchart[nc_idx].str,mstring);
			//printf("unk-expand x -->\n");
		    //print_morpheme_all();
			seg_pos[1].morpheme[seg_pos[1].morph_count++]=nc_idx;
			seg_pos[1].state=SP_STATE_R;
		}
		
	}
	mchart[0].cnt_count=0;

	return anal_chart(0,0);
}




/**
  *  ޾Ƽ anal_chart()Լ ȣϿ ¼Һм  returnϴ Լ̴. 
  * @param word  ¼ м   
  * @return      ¼ м  ִ 迭 index Ѵ. 0̸  , 
  */
morph_anal(char *word)
{

	int MaR;

    init_segment(word);
   // print_segment_pos();
    
    init_chart();
   // print_morpheme_all();
    MaR= anal_chart(0,0);
	
	
	
	/*printf("====\n"); 
	print_morpheme_all();
	printf("====\n"); */
    if(MaR)
		return MaR;
    else if(unk_anal) // ̵Ͼ ó "-u" option     
		return anal_chart_unk();
    else
		return 0;		
	
}
/**
  * ׽Ʈ  mchartü  morpheme ϴ Լ 
 */
print_morpheme(int chart_id)
{
    int i;
	char tmpstr[1024];
    fprintf(stderr,"chart_id=%d, ",chart_id);
    fprintf(stderr,"%s/%s.%s mstate=%d, ", coco_str(TRI,KS,mchart[chart_id].str, tmpstr),
		tagname[mchart[chart_id].tag],
		irrname[mchart[chart_id].phone],
		mchart[chart_id].state);
    fprintf(stderr,"conexion=");
    for(i=0;i< mchart[chart_id].cnt_count;i++)
		fprintf(stderr,"%d, ",mchart[chart_id].connection[i]);
    fprintf(stderr,"\n");
}
/*----------------------------------------------------------------------
print result
----------------------------------------------------------------------*/
int slash_plus(char *str)
{
	while(*str)
	{
		if(*str=='+' || *str =='/')
			return 1;
		str++;
	}
	return 0;
}
char pbuff[MAX_SEGMENT];
char outstr[MAX_SEGMENT];
int print_chart(int chart_id, int pb_end)	// check
{
    int i,j,k;

    /*
    if(mchart[chart_id].state!=SUCCESS)
	return 0;
	*/
//print_morpheme(chart_id);

    if(chart_id == 0)
    {
		pbuff[0]='\t';
		pb_end=1;

		for(i=0;i<mchart[chart_id].cnt_count;i++)
			print_chart(mchart[chart_id].connection[i],pb_end);
    }
    else
    {
		if(indexing)
		{
			if(is_index(mchart[chart_id].tag))
			{
				pbuff[pb_end++]='[';
				strcpy(pbuff+pb_end,mchart[chart_id].str);
				while(pbuff[pb_end]) pb_end++;
					pbuff[pb_end++]=']';
			}
		}
		else
		{
			if(slash_plus(mchart[chart_id].str))
			{
				int i,j;
				char *str;
				str=mchart[chart_id].str;
				j=pb_end;
				for(i=0;str[i];i++,j++)
				{
					if(str[i]=='+' || str[i]=='/')
						pbuff[j++]='\\';
					pbuff[j]=str[i];
				}
				pbuff[j]=0;
			}
			else
				strcpy(pbuff+pb_end,mchart[chart_id].str);
			while(pbuff[pb_end]) pb_end++;
			pbuff[pb_end++]='/';

			//for debug chart
//			sprintf(pbuff+pb_end,"%d:",chart_id);
//			pb_end+=strlen(pbuff+pb_end);


			strcpy(pbuff+pb_end,tagname[mchart[chart_id].tag]);
			while(pbuff[pb_end]) pb_end++;
		}

		for(i=0;i<mchart[chart_id].cnt_count;i++)
		{
			if(mchart[chart_id].connection[i]==0)
			{
				pbuff[pb_end]=0;
				/*
					fprintf(stderr,"%s\n",pbuff);
				*/
				if(pb_end)
				{
					coco_str(TRI,KS,pbuff,outstr);
					//===============
					strcat(cand, outstr);
					strcat(cand,"\n"); 
					//================euni
					//puts(outstr);
				}
			}
			else
			{
				if(indexing)
					print_chart(mchart[chart_id].connection[i],pb_end);
				else
				{
					pbuff[pb_end]='+';
					print_chart(mchart[chart_id].connection[i],pb_end+1);
				}
			}
		}
    }
}
//euni
char *print_result2(int r)
{
   	int i;
	char *str;

        strcpy(cand, "");
    	if(r)
      	 	print_chart(0,0);
	str=cand;
        return str;
}

print_result(int r)
{
        char *str;
	if(r)
        	print_chart(0,0);
	str=cand;
	puts(str);

}

