#ifndef __tags_h
#define __tags_h 1

#define MAXTAG 256
#define MAXIRR 256

#define TAGLEN	16
#define IRRLEN	16
#define TSETLEN 256

extern char tag_title[];
extern char tag_version[];
extern char tag_copyright[];
extern char tag_author[];
extern char tag_date[];
extern char tag_editor[];

extern char tagname[][TAGLEN];		/* tag ̸   */
extern int tagsend;             	/* the no. of tags */

extern char irrname[][IRRLEN];		/* irr ̸   */
extern int irrsend;             	/* the no. of irrs */

extern char tsetname[][TAGLEN];		/* tag set ̸   */
extern unsigned char tset[][TSETLEN];	/* tag set */
extern int tsetend;			/* No. of tag set */

extern int irrnum(char *str);
extern int tagnum(char *str);
extern int tsetnum(char *str);
extern int tagread(char *infname);

#endif
