#ifndef WJ_HAN_CODE_H
#define WJ_HAN_CODE_H 1

#define   TG      1   /*   (ﺸ KSSM, ťн, IBM, ֿ, ) */
#define   KS      6   /* KS ϼ (KS C 5601-1987 ϼ ǥ ڵ) */
#define   TRI     10  /* 3Ʈ ڵ TG Ȯ           */

extern unsigned char *coco_str(int src, int des, unsigned char *str, unsigned char * out);
extern char tojong(char c);
extern char tocho(char c);
extern char tosph(char c);
extern unsigned char tonorm(unsigned char c);

#define TRI_Co 		(unsigned char)(0x80)
#define TRI_Jung 	(unsigned char)(0xa0)
#define TRI_Jong 	(unsigned char)(0xc0)
#define TRI_Sph 	(unsigned char)(0x98)

#define FILL_Co		(unsigned char)(0x01)
#define FILL_Jung	(unsigned char)(0x02)
#define FILL_Jong	(unsigned char)(0x01)

#define is_tri_co(c)	(((c) & 0xe0) == TRI_Co)
#define is_tri_jung(c)	(((c) & 0xe0) == TRI_Jung)
#define is_tri_jong(c)	(((c) & 0xe0) == TRI_Jong)
#define is_tri_riul_jong(c)	(((c) & 0xe0) == TRI_Jong && ((c) & 0x1f) == 0x09)
#define is_tri_sph(c)	(((c) & 0xf8) == TRI_Sph || (c)==(unsigned char)0x97)

#endif /* WJ_HAN_CODE_H  */
