#include <stdio.h>
#include "../share/global.h"
#include "../share/tags.h"
#include "../share/trie.h"
#include "../share/wjhcode.h"

char word[1024];
char wordks[1024];
INFO data[1024];
char buf[1024];
    
main(int argc, char *argv[])
{
    MDIC *tf;
	int tmp;
    int x,y,i;

    if(argc == 3)
	{
		tf= mdic_open(argv[2],'r');
		tmp=tagread(argv[1]);
	}
    else
    {
		fprintf(stderr,"usage: %s tagfile dictfile\n",argv[0]);
		return;
    }
    if(tmp==-1)
    {
		fprintf(stderr,"tagfile '%s' is not exist\n",argv[1]);
		return -1;
	}
    if(tf==NULL)
    {
		fprintf(stderr,"dictfile '%s' is not exist\n",argv[2]);
		return -1;
    }

	word[0]=0;

    for(x=trie_firstkey(tf,word);x>0;x=trie_nextkey(tf,word))
    {
		y=mdic_fetch(tf,word,data);

		tri2ks(word,wordks);
		printf("%s",wordks);
		for(i=0;i<y;i++)
		{
			if (data[i].mtag)
			{
				if (data[i].phone)
					printf(" %s.%s",tagname[data[i].mtag],irrname[data[i].phone]);
				//	printf(" %s.%d",tagname[data[i].mtag],data[i].phone);
				else
					printf(" %s",tagname[data[i].mtag]);
			}
			else printf(" -ERRORTAG-");
		}
		puts("");
    }
    mdic_close(tf);
}

