#define PCONSTANT -4.60517018598809136803 /* ln 0.01 */

void get_tag(char *str, char *tag)
/* str ="¼/tag"
   tag = "tag" 
   */
{
	char *tmp;

	*tag='\0';
	if (*str==NULL) return;
	while(*str && *str!='/')
			str++;
	if (*str==0) return;
	else str++;  /* tag  */
	while(*str)
			*tag++=*str++;
	*tag=0;
	return;
}
double compute_wt(char *str)
{
/* 	P(WP|Ts) Ȯ 
	ex) P( б | б/ncn+/jca )
		= P( б | ncn ) P( ncn | bnk ) * P( |jca ) P( jca | ncn )
*/

	double current_prob;
	char morphtag[128],*tmp,probstr[128];
	char tag[10],bitag[12],oldtag[10]; 

	/* ù° ¼ Ȯ  */
	tmp=front_token(str,morphtag,'+'); /* morphtag = "б/ncn" */
	get_tag(morphtag,tag);	/* tag="ncn" */ 

	/* P(t1|t0) Ȯ  */
	sprintf(bitag,"bnk_%s",tag); 	/* bnk_ncn */
	if (tdbm_fetch(ptt_tf,bitag,probstr))
		/* current = P(t1|t0) */
		current_prob=atof((const char*)probstr);
	else 
		/* current = P(ncn|bnk)=0.01 */
		current_prob=PCONSTANT;

	/* P(w|t) Ȯ  */
	if (tdbm_fetch(pwt_tf,morphtag,probstr))
		/* current *= P(w|t1) */
		current_prob+=atof((const char*)probstr);
	else current_prob+= PCONSTANT;

	strcpy(oldtag,tag);

	while(tmp)
		{
		tmp=front_token(tmp,morphtag,'+');
		get_tag(morphtag,tag);

		/* P(t_i|t_i-1) Ȯ  */
		sprintf(bitag,"%s_%s",oldtag,tag);
		if (tdbm_fetch(ptt_tf,bitag,probstr))
			current_prob+=atof((const char*)probstr);
		else 
			/* current*= P(t_i|t_i-1)=0.01 */
			current_prob+= PCONSTANT;

		/* P(w|t) Ȯ  */
		if (tdbm_fetch(pwt_tf,morphtag,probstr))
			/* current *= P(w|t) */
			current_prob+=atof((const char*)probstr);
		else
			current_prob+=PCONSTANT; 

		strcpy(oldtag,tag);
		}
}


