#ifndef _hmm_h
#define _hmm_h


#include "./SRC/global.h"
#include "./SRC/trie.h"

#define NUM_OF_RULE 15
#define SMOOTH 0.00000000001
#define LAMBDA 0.90

typedef struct{
	char eng[32];
	char kor[32];
	char gen_eng[32];
	char gen_kor[32];
	int  pre_idx;
	int  pre_node_idx;
	float prob;
	int  num;
}Node;

typedef struct{
	char eng[32]; //  
	char kor[32]; // ѱ ڵ 
	int  flag; //  (0) Ǵ  (1)
	char target[32]; // ѱ ڵ ȯ 
}Rule;

TDBM *map, *trans_tdb, *lex_tdb;
int  correct;

Rule	rules[NUM_OF_RULE];


void INIT_HMM();
void ek_trans_hmm_as_string(char*, char*);
void END_HMM();

#endif