/* coco	v1.0
	ڵ庯ȯ mainα׷

	 :
	coco <src><des> [infile [outfile]]
	src, des:	t = TriGem (KSSM)
              	k = KS C 5601-1987 complete
				3 = 3 byte code for hangul reversed list

*/

#include <stdio.h>
#include "../src/share/wjhcode.h"

#define LINE_LIMIT 2048
unsigned char line[LINE_LIMIT], line2[LINE_LIMIT];

char *usage =  
"   src, des : t = TriGem (KSSM)\n\
              k = KS C 5601-1987 complete\n\
              3 = 3 byte code for hangul reversed list\n";

void show_usage(char *cmd, int des)
{
	fprintf(stderr, "Usage: %s <src><des> [infile [outfile]]\n",cmd);
	fprintf(stderr, "Usage: %s <des>  : show usage in <des> code\n",cmd);
	if(des == KS)
		fprintf(stderr, usage);
	else
	{
		coco_str(KS,TG,usage,line);
		fprintf(stderr, line);
	}
	exit(1);
}

unsigned char tmpstr[LINE_LIMIT];
int main(int ac, char **av)
{
	short    c, c2;
	short    src, des;
	FILE   *fp, *gp;

	if (ac < 2) 
		show_usage(av[0],KS);

	switch (av[1][0]) 
	{
		case 't': src = TG; break;
		case 'k': src = KS; break;
		case '3': src = TRI; break;
		default : show_usage(av[0],KS);
	}
	switch (av[1][1]) 
	{
		case 't': des = TG; break;
		case 'k': des = KS; break;
		case '3': des = TRI; break;
		default : show_usage(av[0],src);
	}

	if(src == des)
		show_usage(av[0],src);
	if (ac <= 2)
		fp = stdin;
	else 
	{
		if ((fp = fopen(av[2], "r")) == NULL) 
		{
			fprintf(stderr, "can't open file: %s\n", av[2]);
			exit(1);
		}
	}

	if (ac <= 3)
		gp = stdout;
	else 
	{
		if ((gp = fopen(av[3], "w")) == NULL) 
		{
			fprintf(stderr, "can't open file: %s\n", av[3]);
			exit(1);
		}
	}
	
	while (fgets(line,LINE_LIMIT,fp) != 0) 
	{
		coco_str(src,des,line,line2);
		fputs(line2,gp);
	}

	fclose(fp);
	fclose(gp);
}
