#include <stdio.h>
#include "../src/share/trie.h"
#include "../src/share/global.h"
#include "../src/share/wjhcode.h"

char HA[32];
char AR[32];
char A_[32];
char PV[32];
char XEU[32];
char DOB[32];
char GOB[32];
char EU[32];
char SU[32];
char NU[32];

char word[1024];
char data[1024];

char line[1024];
char processing[400][1024];
int p_end=0;

action()
{
    int i;
    if(p_end==0)
		return;

    puts(processing[0]);
    for(i=1;i<p_end;i++)
		printf("\t%s\n",processing[i]);
    puts("");
    p_end=0;
}

char tmpword[1024];
char tmptag[1024];
char tmpstr[1024];
char prevword[1024];
char tmpmorph[1024];
char buff[1024];

int is_pvowel(char c)
{
	int i;
	for(i=0;PV[i];i+=2)
		if(PV[i]==c)
			return 1;
	return 0;
}

int is_xeu(char c)
{
	int i;
	for(i=0;XEU[i];i++)
		if(XEU[i]==c)
			return 1;
	return 0;
}

morph_in(char *str)
{
    char *p, *q;
    int i=0;

	if(*str=='\t')
		str++;

    tmpstr[0]=0;
	prevword[0]=0;
	
	// ¼ м  1   ¼ҿ Ͽ
    for( p=front_morph(tmpmorph,str); p!=NULL;p=front_morph(tmpmorph,p))
    {
		q=front_wt(tmpword,tmpmorph);
		strcpy(tmptag,q);

		//  ,, Ż Ű 
		if(tmptag[0]=='e')
		{
			int len;
			len=strlen(prevword);
			coco_str(KS,TRI,tmpword,buff);

			if(strncmp(buff,A_,2)==0) 	/*  -> */
			{
				if(len>=4 && 								//  
						prevword[len-1] == EU[1] &&
						!is_xeu(prevword[len-2])  &&
						( (is_tri_jung(prevword[len-3]) 
							&& is_pvowel(prevword[len-3])) ||
							(is_tri_jong(prevword[len-3]) 
							&& is_pvowel(prevword[len-4])) )) 
				{
					strncpy(buff,AR,2);
					coco_str(TRI,KS,buff,tmpword);
				}
				else if(len>=3 && prevword[len-1]==DOB[2] &&
								(strcmp(prevword+len-3,DOB) != 0 ||
								strcmp(prevword+len-3,GOB) != 0))
					; // ұĢ  
				else if(len>=2 && strcmp(prevword+len-2,HA) == 0)
					;
				else if(len>=2 && ( (is_tri_jung(prevword[len-1]) // 
							&& is_pvowel(prevword[len-1])) ||
							(is_tri_jong(prevword[len-1]) 			// 
							&& is_pvowel(prevword[len-2])) )) 
				{
					strncpy(buff,AR,2);
					coco_str(TRI,KS,buff,tmpword);
				}
			}
			else if(strncmp(buff,EU,2)==0 || 	/*  Ż */
					strncmp(buff,SU,4)==0 ||
					strncmp(buff,NU,4)==0)
			{
					if(len>=2 && (is_tri_jung(prevword[len-1]) ||
								is_tri_riul_jong(prevword[len-1])))
						coco_str(TRI,KS,buff+2,tmpword);
			}
			// if(strncmp(tmpmorph,"",2)==0)
		}
		strcpy(tmpstr+i,tmpword); i+=strlen(tmpword);
		strcpy(tmpstr+i,"/"); i++;
		strcpy(tmpstr+i,tmptag); i+=strlen(tmptag);
		strcpy(tmpstr+i,"+"); i++;
		coco_str(KS,TRI,tmpword,prevword);
    }

	tmpstr[i-1]=0;

    for(i=1;i<p_end;i++)
		if(strcmp(processing[i],tmpstr)==0)
			break;
    if(i<p_end)
		;
    else
    {
		strcpy(processing[p_end],tmpstr);
		p_end++;
    }
}

word_in(char *str)
{
    if(p_end)
		action();

    strcpy(processing[0],str);
    p_end=1;
}
    
main(int argc, char *argv[])
{

    p_end=0;

	coco_str(KS,TRI,"",HA);
	coco_str(KS,TRI,"",AR);
	coco_str(KS,TRI,"",A_);
	coco_str(KS,TRI,"",PV);
	coco_str(KS,TRI,"߾ũƮ",XEU);
	coco_str(KS,TRI,"",DOB);
	coco_str(KS,TRI,"",GOB);
	coco_str(KS,TRI,"",EU);
	coco_str(KS,TRI,"",SU);
	coco_str(KS,TRI,"´",NU);

	while(gets(line) != NULL)
    {
		if(line[0]==0)
			action();
		else if(isspace(line[0]))
			morph_in(line);
		else
			word_in(line);
    }
    action();
}

