#include <stdio.h>
#include <ctype.h>
#include "malib.h"
#include "../share/wjhcode.h"
#include "../share/global.h"
#include "../share/trie.h"
#include "detect.c"

char ARG[MAX_LINE];
char line[MAX_LINE];
char word[MAX_WORD];
char ans[MAX_WORD];
char mout[MAX_WORD];
char mout1[MAX_WORD];
char cand[MAX_LINE][1024]; 
char final[1000][4096];
char t_tmp[1024];

int hanja[100];
char each[100][4];
int num, cand_ind, final_ind;

int anal_dic=0;

char *pre_out(char *str);
char *pre_out2(char *str);
char *process_chi_eng(char *str);
void analyze (char *str);
void process_paren(char str[]);

main(argc, argv)
int argc;
char *argv[];
{
	int i,r,c,m,k,f_arg,j=0;
	char *rword;
	char *pa, *p, *g;
	TDBM *tf;
	int flag;

	m=argc;	
	strcpy(cfg_file,"/home2/cwseo/ma.cfg");

	while (m>=2) {
		c=argc-m+1;

		if (!strcmp(argv[c],"--help")) {
			fprintf(stderr,"Usage : %s [-[ilntuU]] [@<cfgfile>]\n",argv[0]);
			fprintf(stderr,"Option - l : ġ\n");
			fprintf(stderr,"       - u : м о   ó (unk ± )\n");
			fprintf(stderr,"       - U : м о   ǰ ĺ \n");
//			fprintf(stderr,"       - Y : м о   ȶϰ óϱ \n");
			fprintf(stderr,"       - i : ε̿  \n");
			fprintf(stderr,"       - t : top-down  \n");
			/* begin - added by yuntan 20000607 : м ɼ ߰ */
			fprintf(stderr,"       - n : м  \n");
			/* end - added by yuntan 20000607 */
			return;
		} else if (!strncmp(argv[c],"-w",2)) {
			if (m>=3) {
				strcpy(ARG,argv[c+1]);
				f_arg = 1;
				m--;
			}
		} else if (argv[c][0]=='-') {
			for (i=1;argv[c][i];i++) {
				if (argv[c][i]=='l') {
					if (longest == 0) longest=1;
					else fprintf(stderr,"Conflict option \'-l\'\n");
				} else if(argv[c][i]=='u') {
					if (unk_anal == 0) unk_anal=1;
					else fprintf(stderr,"Conflict option \'-u\'\n");
				} else if (argv[c][i]=='U') {
					if (unk_expand==0) unk_anal = unk_expand = 1;
					else fprintf(stderr,"Conflict option \'-u\'\n");
				} else if (argv[c][i]=='i') {
					if (indexing == 0 ) indexing=1;
					else fprintf(stderr,"Conflict option \'-i\'\n");
				} else if (argv[c][i]=='t') {
					if (top_down == 0 ) top_down=1;
					else fprintf(stderr,"Conflict option \'-t\'\n");
			/* begin - added by yuntan 20000607 : м ɼ ߰ */
				} else if (argv[c][i]=='n') {
					if (anal_dic == 0 ) anal_dic=1;
					else fprintf(stderr,"Conflict option \'-n\'\n");
			/* end - added by yuntan 20000607 */
			/* begin - added by yuntan 20000929 : ̵Ͼ ġ ɼ ߰ * /
				} else if (argv[c][i]=='Y') {
					if (unk_anal == 0 ) unk_anal=2;
					else fprintf(stderr,"Conflict option \'-Y\'\n");
			/* end - added by yuntan 20000929 */
				}
			}
		} else if (argv[c][0]=='@') 
			strcpy(cfg_file,argv[c]+1);


		/*
					 fprintf(stderr,"anal_dic=%d\n",anal_dic);
					 */
					 
		m--;
	}
	if (!strlen(cfg_file)) strcpy(cfg_file,"ma.cfg");
	/*
	if(argc>=2 && argv[1][0]=='-')
	for(i=1;argv[1][i] ; i++)
	{
		if(argv[1][i]=='l')
			longest=1;
		else if(argv[1][i]=='u')
			unk_anal=1;
		else if(argv[1][i]=='U')
		{
			unk_anal=1;
			unk_expand=1;
		}
		else if(argv[1][i]=='i')
			indexing=1;
		else if(argv[1][i]=='t')
			top_down=1;
	    if (argc>=3) 
			strcpy(cfg_file,argv[2]);
		else strcpy(cfg_file,"ma.cfg");
	} else if (argc>=2) {
		strcpy(cfg_file,argv[1]);
	} else {
		strcpy(cfg_file,"ma.cfg");
	}

	*/
	init_morph();

// edited by cwseo 
// tf=tdbm_open("/home/wjlee/study/ma990818/analyzed",'r');
	tf=tdbm_open(ana_file,'r');

//	fprintf(stderr,"%s\n%s\n%s\n%s\n%s\n",udict_file,sdict_file,cnt_file,tag_file,ana_file);
	if (f_arg == 1) {
		strcpy(word,ARG);
				if(!anal_dic && tf != NULL && tdbm_fetch(tf,word,mout)>0)
				{
// м  
					printf("@%s\n",word);
					for(p=front_token(mout1,mout,'^');
							p != NULL;
							p=front_token(mout1,p,'^'))
						printf("\t%s\n",mout1);
				}
				else
				{
					pa=strstr(word, "(");
		         	printf(" %s\n",word);
		            g=word;
		            if (pa && word[0]!='(') process_paren(word);
		            else analyze(g);
		            for (k=0; k<final_ind; k++)
		            printf("%s\n", final[k]);
				}
			puts("");

	} else 
	while(gets(line) != NULL)
	{
		flag =0;
		if (strstr(line,"\t")!=NULL) {
			char *p = strstr(line,"\t");
			*p = '\0';
			strcpy(ans,p+1);
			if (strstr(ans,"\n")!=NULL) *strstr(ans,"\n")='\0';
			if (strstr(ans,"\r")!=NULL) *strstr(ans,"\r")='\0';
		}
	 	if (!strncmp(line,"<TERM",5) ||
				 !strncmp(line,"</TERM",6) ||
				 !strncmp(line,"<ID",3) ||
				 !strncmp(line,"</ID",4)) {
			puts(line);
			continue;
		}
		for(rword = front_word(word,line); rword != NULL; rword = front_word(word,rword)) 
		{
			final_ind=0;
// BOS indicate the begining of a sentence
			if(strstr(word,"BOS") !=NULL) 
				puts("BOS");
// EOS indicate the end of a sentence
			else if (strstr(word,"EOS") != NULL)
				puts("EOS");
			else
			{
				if(!anal_dic && tf != NULL && tdbm_fetch(tf,word,mout)>0&&1!=1)
				{
// м  
					printf(" %s\t%s\n",word,ans);
					for(p=front_token(mout1,mout,'^');
							p != NULL;
							p=front_token(mout1,p,'^'))
						if (strstr(mout1,ans)!=NULL) {
							printf("O");
							flag = 1;
						} else printf("X");
						printf("\t%s\n",mout1);
				}
				else
				{
					pa=strstr(word, "(");
					printf(" %s\t%s\n",word,ans);
					g=word;
					// ӿ ȣ ԵǾ   process_paren, ׷   analyze ȣ
					//ȣ ԵǾ ־ ùڰ '('  process_paren ȣ
					if (pa && word[0]!='(') process_paren(word);
					else analyze(g);
					for (k=0; k<final_ind; k++) {
						if (strstr(final[k],ans)!=NULL) {
							printf("O");
							flag =1 ;
						} else printf("X");
						printf("%s\n", final[k]); // 
					}
				}
				if (flag==1) printf("## O %s\t%s\n",word,ans);
				else printf("## X %s\t%s\n",word,ans);
			}
			puts("");

		}
	}
	close_morph();
	if(tf != NULL)
		tdbm_close(tf);
}

// ӿ ȣ Ե 츦 ó
// ȣ տ ̽ ־   cartesian product
// Է ޾Ƽ ó  final̶ 迭 
void process_paren(char str[])
{
	char *pos, *rw, *g, *t;
	char tok[100], sp[100][100], w[MAX_WORD];
	int ind, i, j, k, l;

	ind=i=0;
	pos=strtok(str, "(");
	strcpy(tok, pos);
	while (pos!=NULL)
	{
		strcpy(sp[ind], pos);
		ind++;
		pos=strtok(NULL, "(");
	}
	for (j=1; j<ind; j++)
	{
		strcat(tok, " (");
		strcat(tok, sp[j]);
	}
	ind=j=0;
	for(rw = front_word(w,tok); rw != NULL; rw = front_word(w,rw))
	{
		l=0;
		g=w;
		analyze(w);
		if (j==0)
			for (i=0; i<cand_ind; i++)
					strcpy(final[i],cand[i]);
		else
		{
			for (i=1; i<cand_ind+1; i++)
				for (k=0; k<final_ind; k++)
					strcpy(final[final_ind*i+k], final[k]);
			for (i=0; i<cand_ind; i++)
			{
				for (k=0; k<final_ind; k++)
				{
					ind=l*final_ind+k;
					strcat(final[ind], "+");
					t=strtok(cand[i], "\t");
					strcat(final[ind], t);
				}
				l++;
			}
		}
		j++;
	}
	final_ind=ind+1;
}

//  ¼ м 
//final  

void process_term(char *kk,char *str)
{
	char *p;
	int i,j;
	if (strstr(str,"<TERM")==NULL) {
		strcpy(kk,str);
		return;
	}

	for (j=0,p=str;*p!='\0';p++,j++) {
		if (*p=='<') {
			p+=strlen("<TERM:");
			for (i=0;*p!='>';p++) {
				t_tmp[i++]=*p;
			}
			t_tmp[i]='\0';
			kk[j++]='#';
			kk[j++]='#';
			kk[j++]='#';
			kk[j++]='#';
			p++;
		}
		kk[j]=*p;
	}
	kk[j]='\0';
}

void analyze (char *str)
{
	char  *gg, *output, *temp;
	char obj[10240], in[1000][100], word2[MAX_WORD], eoj[MAX_LINE]; 
	char kk[1024];
	int r;
	cand_ind=0;
	process_term(kk,str);
	gg=process_chi_eng(kk);
	if (strstr(gg,"####")!=NULL) {
		strncpy(strstr(gg,"####"),"TTTT",4);
	}
    strcpy(eoj, gg);
    coco_str(KS,TRI,eoj,word2);
    r=morph_anal(word2);
    output=print_result2(r);
	strcpy(obj, output);
	gg=strtok(obj, "\n");
	while (gg!=NULL) {
		strcpy(in[cand_ind], gg);
		temp=in[cand_ind];
		gg=strtok(NULL, "\n");
    	output=pre_out(temp);
		strcpy(cand[cand_ind], output);
		cand_ind++;
	}
	if (final_ind==0)
	{
		for (r=0; r<cand_ind; r++)
			strcpy(final[r],cand[r]);
		final_ind=cand_ind;
	}

}

//ڿ  "HHHHH" "AAAAA" ġȯ
char *process_chi_eng(char *str)
{
	
	int i, j, h;
	char *result;
	char temp[100];
	char *gar;
	int flag, flag1;

	i=j=0;
	flag=flag1=0;
	temp[0]=0;
	
	while (i<strlen(str))
	{
		h=han_type(str+i, gar);
		if (h==0) {
			strcpy(each[j], str+i);
			each[j][1]=0;
			j++;
			i++;
		}
		else { 
			strcpy(each[j], str+i);
			each[j][2]=0;
			j++;
			i=i+2;
		}
	}
	num=j;
	for (i=0;i<j; i++)
	{
		hanja[i]=han_type(each[i], gar);
		if (hanja[i]==-2) {
			if (flag!=1) {
				strcat(temp, "HHHHH");
				flag=1;
				flag1=0;
			}
		}
		else if (hanja[i]==0) {
			if (isalpha(each[i][0])) {
				hanja[i]=3;
				if (flag1!=1) {
					strcat(temp, "AAAAA");
					flag1=1;
					flag=0;
				}
			}
			else {
				strcat(temp, each[i]);
				flag=0;
				flag1=0;
			}
		}
		else {
			strcat(temp, each[i]);
			flag=0;
			flag1=0;
		}
	}
	result=temp;
	return result;

}

//¼ м  ִ HHHHH  ڿ ġȯ
char *pre_out(char *str)
{
	char *tok, *be, *result;
	int i, j, l;
	int flag;
	char line1[100], line2[100];
	char mp[100];

	if ((be=strstr(str,"TTTT"))!=NULL) {
		*be ='\0';
		strcpy(mp,be+4);
		strcpy(be,t_tmp);
		strcat(str,mp);
	}
	be=strstr(str, "HHHHH");
	if (!be) {
		result=pre_out2(str);
		return result;
	}
	else {
		strcpy(line1, str);
		flag=0;
		j=0;
		line2[0]=0;
		
		tok=strtok(line1, "HHHHH");
		while (tok!=NULL) {
			strcat(line2, tok);
			for (i=j;i<num;i++) {
				if (hanja[i]==-2) {
					strcat(line2, each[i]);
					flag=1;
				}
				else if (flag==1) {
					j=i+1;
					flag=0;
					break;
				}
				if (i==j) j=i+1;
			}
			tok=strtok(NULL, "HHHHH");
		}
		be=line2;
		result=pre_out2(be);
		
		return result;
	}
}

//¼ м  ִ AAAAA  ڿ ġȯ
char *pre_out2(char *str)
{
	char *tok, *be, *result;
	int i, j, l;
	int flag;
	char line1[100], line2[100];

	be=strstr(str, "AAAAA");
	if (!be) {
		return str;
	}
	else
	{
		strcpy(line1, str);

		flag=0;
		j=0;
		line2[0]=0;

		tok=strtok(line1, "AAAAA");
		while (tok!=NULL) {
			strcat(line2, tok);
			for (i=j;i<num;i++) {
				if (hanja[i]==3) {
					strcat(line2, each[i]);
					flag=1;
				}
				else if (flag==1) {
					j=i+1;
					flag=0;
					break;
				}
				if (i==j) j=i+1;
			}
			tok=strtok(NULL, "AAAAA");
		}
		be=line2;
		return be;
	}
}


