/***********************************************************************
	tags.c : tagwrite.c tagread.c  
	standard tag form о̴ α׷
***********************************************************************/
#include <stdio.h>

#include <sys/types.h> 	/* for open() */
#include <sys/stat.h>
#include <fcntl.h>

#include "tags.h"
#include "global.h"

/* data to read */
char tag_title[256];
char tag_version[256];
char tag_copyright[256];
char tag_author[256];
char tag_date[256];
char tag_editor[256];

/*
	tags tagset ׻ 1 Ѵ. 0  ʴ´.
*/
char tagname[MAXTAG][TAGLEN];		/* tags */
int tagsend=1;               	/* the no. of tags */

char irrname[MAXIRR][IRRLEN];		/* irrs */
int irrsend=1;               	/* the no. of irrs */

char tsetname[MAXTAG][TAGLEN];		/* tag set */
unsigned char tset[MAXTAG][TSETLEN];
int tsetend=1;               	/* the no. of tag set */


/**
  *־ ± ̸ ´ ±׹ȣ ȯϴ Լ.
  * @param str  : ±׸ ǹϴ ڿ
  * @return     : ־ ±׸ ϴ ±׹ȣ
  */
int tagnum(char *str)
{
	char *tagpos;
	tagpos = (char *)bsearch(str,tagname+1, tagsend-1,
		TAGLEN,(int (*)(const void *,const void *))ustr_cmp);
	if(tagpos == NULL)
		return -1;
	else
		return (int)(tagpos - (char*)tagname)/TAGLEN;


}

/**
  *־ ± ̸ ´ index ȯϴ Լ.
  * @param str  : ±׸ ǹϴ ڿ
  * @return     : ־ ±׸ ϴ ε
  */
int irrnum(char *str)
{
	char *irrpos;
	irrpos = (char *)bsearch(str,irrname+1, irrsend-1,
		IRRLEN,(int (*)(const void *,const void *))ustr_cmp);
	if(irrpos == NULL)
		return -1;
	else
		return (int)(irrpos - (char*)irrname)/IRRLEN;
}

/**
  *־ ± ̸ ´ ±׹ȣ ȯϴ Լ.
  * @param str  : ±׸ ǹϴ ڿ
  * @return     : ־ ±׸ ϴ ±׹ȣ
  */
int tsetnum(char *str)
{
        char *tsetpos;
        tsetpos = (char *)bsearch(str,tsetname+1, tsetend-1,
                TAGLEN,(int (*)(const void *,const void *))ustr_cmp);
        if(tsetpos == NULL)
                return -1;
        else
                return (int)(tsetpos - (char*)tsetname)/TAGLEN;
}

/**
  * ־ ڿ ̸ ϴ Ϸκ ±  о ޸𸮿 εϴ Լ 
  * @param str  : tag, irrs, tagset о file ̸.
  * @return     : б⿡ ϸ 0 Ѵ. 
  */
int tagread(char *infname)
{
	int i;
	int tagfile;

	if((tagfile = open(infname,O_RDONLY)) == -1)
	{
/*
		fprintf(stderr,"Error : can not open [%s]\n",infname);
		exit(0);
*/
		return -1;
	}
	/* -------------------------------
		reading 
	------------------------------- */
	read(tagfile,tag_title,256);
	read(tagfile,tag_version,256);
	read(tagfile,tag_copyright,256);
	read(tagfile,tag_author,256);
	read(tagfile,tag_date,256);
	read(tagfile,tag_editor,256);
	read(tagfile,&tagsend,sizeof(int));
	for(i=1;i<tagsend;i++)
		read(tagfile,tagname[i],TAGLEN);
	read(tagfile,&irrsend,sizeof(int));
	for(i=1;i<irrsend;i++)
		read(tagfile,irrname[i],IRRLEN);
	read(tagfile,&tsetend,sizeof(int));
	for(i=1;i<tsetend;i++)
		read(tagfile,tsetname[i],TAGLEN);
	for(i=1;i<tsetend;i++)
		read(tagfile,tset[i],TSETLEN);

	close(tagfile);
	return 0;
}

