#include <stdio.h>
#include <string.h>
#include "../share/tags.h"
#include "../share/trie.h"
#include "../share/global.h"

char line[1024];
char word[1024];
char data[1024];
INFO taglist[255];
    
main(int argc, char *argv[])
{
    char *p,*q;
    int x,a,isize,i;
    int count=0;
	char cur_t[128],cur_ir[128];
    FILE *infile;
   	MDIC *tf;

    if(argc >= 3)
	{
		tf= mdic_open(argv[2],'w');
		a=tagread(argv[1]);
	}
    else
    {
		fprintf(stderr,"usage: %s tagfile dictfile < testfile\n",argv[0]);
		return;
    }

    if(argc >= 4)
		infile=fopen(argv[3],"r");
    else
		infile=stdin;

    if(tf==NULL)
    {
		fprintf(stderr,"dictfile '%s' is not exist\n",argv[2]);
		return;
    }
    if(a==-1)
    {
		fprintf(stderr,"tagfile '%s' is not exist\n",argv[1]);
		return;
    }

    while(fgets(line,1024,infile)!=NULL)
    {
		p=front_word(word,line);
		isize=0;
		while(p=front_word(data,p))
		{
//				fprintf(stderr,"--%s\n",p);
			q=front_token(cur_t,data,'.');
//				fprintf(stderr,"%s %s",data,cur_t,q);
			if (*q)
			{
//				fprintf(stderr,".[%s]\n",q);
				taglist[isize].phone=irrnum(q);
			}
			else 
				taglist[isize].phone=0;
			x=tagnum(cur_t);
			if (x==-1) 
				fprintf(stderr,"tag error in insert %s - %s\n",word,cur_t);
			else taglist[isize].mtag=x;
			isize++;
			// 
			// mdic_fetch(tf,word,inode)  tag  ġ ʳ ˻ؾ
			// ⼭ 
			//
		}
		taglist[isize].mtag=0;
		taglist[isize].phone=0;

		for(i=0;i<isize;i++)
		{
			// Word_ID ⼭  .
			mdic_store(tf,word,taglist+i);
		}
		count+=isize;

		/*
		if(x>0)
		{
	   		sprintf(tag2,"%s %s",data,tag);
	    	tdbm_store(tf,word,tag2,TDBM_REPLACE);
		}
		else tdbm_store(tf,word,tag,TDBM_INSERT);
		*/
    }
    fprintf(stderr,"%s %d entries inserted\n",argv[0],count);
    mdic_close(tf);
}

