/*********************************************************************** cntread.c

	standard cnt form о̴ α׷
***********************************************************************/

#include <stdio.h>

#include <sys/types.h> 	/* for open() */
#include <sys/stat.h>
#include <fcntl.h>

#include "../share/tags.h"
#include "../share/cnt.h"

int main(int argc, char *argv[])
{
	int i=0,j;		/* i,j : general index */

	if(argc < 2)
	{
		fprintf(stderr,"%s <infile>\n",argv[0]);
		fprintf(stderr,"\t<infile> : standard cnt_data_type file\n");
		exit(0);
	}
	
	cntread(argv[1]);

	fprintf(stdout,"T %s\n",cnt_title);
	fprintf(stdout,"V %s\n",cnt_version);
	fprintf(stdout,"C %s\n",cnt_copyright);
	fprintf(stdout,"A %s\n",cnt_author);
	fprintf(stdout,"D %s\n",cnt_date);
	fprintf(stdout,"E %s\n",cnt_editor);
	fprintf(stdout,"V %s\n",ct_version);
	fprintf(stdout,"ST%d\n",cnt_start_tag);
	fprintf(stdout,"TE%d\n",tagsend);
	for(i=1;i<tagsend;i++)
	{
		for(j=1;j<32;j++)
			fprintf(stdout,"\\x%02x ",ctable[i][j]);
		fprintf(stdout,"\n");
	}
	
}
