/***********************************************************************
	tagread.c

	standard tag form о̴ α׷
***********************************************************************/

#include <stdio.h>

#include <sys/types.h> 	/* for open() */
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>

#include "../share/tags.h"

int main(int argc, char *argv[])
{
	int i=0,j;		/* i,j : general index */

	if(argc < 2)
	{
		fprintf(stderr,"%s <infile>\n",argv[0]);
		fprintf(stderr,"\t<infile> : standard tag_data_type file\n");
		exit(0);
	}
	
	if(tagread(argv[1]) == -1)
                perror("error");
 
/*
	for(i=1;i<tsetend;i++)
		fprintf(stdout,"%s--\n",tsetname[i]);
*/
		
	fprintf(stdout,"%s--\n",argv[1]);
	fprintf(stdout,"T %s\n",tag_title);
	fprintf(stdout,"V %s\n",tag_version);
	fprintf(stdout,"C %s\n",tag_copyright);
	fprintf(stdout,"A %s\n",tag_author);
	fprintf(stdout,"D %s\n",tag_date);
	fprintf(stdout,"E %s\n",tag_editor);
	for(i=1;i<tagsend;i++)
		fprintf(stdout,"t%d: %s\n",i,tagname[i]);
	for(i=1;i<irrsend;i++)
		fprintf(stdout,"p%d: %s\n",i,irrname[i]);
		
}
