#define PCONSTANT -20.0
#define LAMBDA	0.9

const double Lambda1= LAMBDA;
const double Lambda2= 1.0 - LAMBDA;

void get_tag(char *str, char *tag)
/* str ="¼/tag"
   tag = "tag" 
   */
{
	char *tmp;
	*tag=0;
	tmp=front_token(tag,str,'/');
	tmp=front_token(tag,tmp,'+');

	return;
}

double compute_wt(char *str)
{
/* P(T_i, W_i) Ȯ Ѵ.
 * T_i ⼭ ʿ.
*/

	double current=0.0,tbigram,tunigram,lexicon;
	// by jjaeh -  ̵Ͼ ִ.
	//char morphtag[128],*tmp,probstr[128];
	char morphtag[1024],*tmp,probstr[128];
	char tag[10],bitag[12],oldtag[10]; 
	int pos;

	//printf("str:%s\n", str);

	/* ù° ¼ Ȯ  */
	//tmp=front_token(morphtag,str,'+');  /* morphtag = "б/ncn" */
	//get_tag(morphtag,tag);				/* tag="ncn" */ 


	// by jjaeh	-- \/ \+  skip ؾ 
	pos = 1; 
	while(!(str[pos-1]!='\\' && str[pos]=='+') && pos<strlen(str)) pos++;
	strncpy(morphtag, str, pos);
	morphtag[pos]=0;

	//printf("morphtag : %s\n",morphtag);

	if(pos>=strlen(str)) { pos = strlen(str)-1; }
	tmp = &str[pos+1];
	//printf("tmp : %s\n",tmp);

	pos = strlen(morphtag)-1; 
	while(morphtag[pos]!='/') pos--;
	strcpy(tag, &morphtag[pos+1]);

	//printf("tag : %s\n",tag);


/*	fprintf(stderr,"[%s]-tmp:[%s]-tag:[%s]\n",morphtag,tmp,tag); */

	/* P(t1|t0) Ȯ  */
	strcpy(bitag,"bnk-");
	strcat(bitag,tag);	/* bnk_ncn */
	if (tdbm_fetch(ptt_tf,bitag,probstr))
		/* current = P(t1|t0) */
		tbigram=atof((const char*)probstr);
	else 
		/* current = P(t1|t0)=0.01 */
		tbigram=PCONSTANT;

	/* P(t1) Ȯ  : interpolation ϱ Ͽ */
	if (tdbm_fetch(ptt_tf,tag,probstr))
		/* current = P(t1) */
		tunigram=atof((const char*)probstr);
	else 
		/* current = P(t1)=0.01 */
		tunigram=PCONSTANT;

	/* P(w|t) Ȯ  */
	if (tdbm_fetch(pwt_tf,morphtag,probstr))
		/* current *= P(w|t1) */
		lexicon=atof((const char*)probstr);
	else lexicon= PCONSTANT;

	/*                              
	 *  Ȯ = P(w|t1) * P(t1|t0)
	 *                               Lambda1       Lambda2
	 *          ~= P(w|t1) *(P(t1|t0)       * P(t1)
	 *          (, Lambda1 + Lambda2 = 1) 
	current= lexicon + Lambda1*tbigram + Lambda2*tunigram;
	 */

	/*  Ȯ = P(w|t1)/P(t1) * P(t1|t0)/P(t1)
	current = lexicon - tunigram + tbigram - tunigram;
	 */

	current = lexicon + tbigram ;
	/*  Ȯ = P(w|t1) * P(t1|t0)
	 */
	strcpy(oldtag,tag);


	while(tmp && *tmp)
		{
	//	tmp=front_token(morphtag,tmp,'+');
	//	get_tag(morphtag,tag);

	//printf("in tmp : %s\n",tmp);
	pos = 1; 
	while(!(tmp[pos-1]!='\\' && tmp[pos]=='+') && pos<strlen(tmp)) pos++;
	strncpy(morphtag, tmp, pos);
	morphtag[pos]=0;

	if(pos>=strlen(tmp)) { pos = strlen(tmp)-1; }
	tmp = &tmp[pos+1];

	pos = strlen(morphtag)-1; 
	while(morphtag[pos]!='/') pos--;
	strcpy(tag, &morphtag[pos+1]);

	//printf("result : %s&%s\n",morphtag, tag);


/*	fprintf(stderr,"[%s]-tmp:[%s]-tag:[%s]\n",morphtag,tmp,tag); */

		/* P(t_i|t_i-1) Ȯ(bigram)  */
		strcpy(bitag,oldtag);
		strcat(bitag,"-");
		strcat(bitag,tag);	/* bnk_ncn */

		if (tdbm_fetch(ptt_tf,bitag,probstr))
			tbigram=atof((const char*)probstr);
		else 
			tbigram=PCONSTANT;
		/*fprintf(stderr,"P(%s)=%s : %lf\n",bitag,probstr,tbigram);

		/* P(w|t) Ȯ  */
		if (tdbm_fetch(pwt_tf,morphtag,probstr))
			/* current *= P(w|t) */
			lexicon=atof((const char*)probstr);
		else
			lexicon=PCONSTANT; 
		
		/* P(t) Ȯ  */
		if (tdbm_fetch(ptt_tf,tag,probstr))
			/* current = P(t) */
			tunigram=atof((const char*)probstr);
		else 
			/* current = P(t)=0.01 */
			tunigram=PCONSTANT;

		/*
		 *  Ȯİ 
		current+= lexicon-tunigram + tbigram-tunigram;
		*/
		current+= lexicon + tbigram;

		strcpy(oldtag,tag);
		}

	/*  鿡 ؼ */
	strcat(bitag,oldtag);
	strcpy(bitag,"-bnk");

	/* P(bnk|t_last) */
	if (tdbm_fetch(ptt_tf,bitag,probstr))
		tbigram=atof((const char*)probstr);
	else 
		tbigram=PCONSTANT;

	/* P(bnk) Ȯ ,  ȭ ų  .*/
	if (tdbm_fetch(ptt_tf,"bnk",probstr))
		/* current = P(bnk) */
		tunigram=atof((const char*)probstr);
	else 
		tunigram=PCONSTANT;

	/* P(w|bnk) = 1, ln 0 ȴ. */

	/* ʱ Ǽ
	current+= 0 -tunigram + tbigram-tunigram; */

	current+= 0 + tbigram;

	return current;
}


