#define PCONSTANT -4.60517018598809136803 /* ln 0.01 */
#define LAMBDA	0.9

const double Lambda1= LAMBDA;
const double Lambda2= 1.0 - LAMBDA;

void get_tag(char *str, char *tag)
/* str ="¼/tag"
   tag = "tag" 
   */
{
	char *tmp;

	*tag='\0';
	if (*str==NULL) return;
	while(*str && *str!='/')
			str++;
	if (*str==0) return;
	else str++;  /* tag  */
	while(*str)
			*tag++=*str++;
	*tag=0;
fprintf(stderr, "I'm get_tag???. %s\n", tag);

	return;
}
double compute_wt(char *str)
{
/* 	P(WP|Ts) Ȯ 
	ex) P( б | б/ncn+/jca )
		= P( б | ncn ) P( ncn | bnk ) * P( |jca ) P( jca | ncn )
*/

	double current,tbigram,tunigram,lexicon;
	char morphtag[128],*tmp,probstr[128];
	char tag[10],bitag[12],oldtag[10]; 

	/* ù° ¼ Ȯ  */
	tmp=front_token(morphtag,str,'+'); /* morphtag = "б/ncn" */
	if (!tmp)
		get_tag(morphtag,tag);	/* tag="ncn" */ 
fprintf(stderr, "I'm yuntan???. %s, %s\n", morphtag, tag);

	/* P(t1|t0) Ȯ  */
	strcpy(bitag,"bnk_");
fprintf(stderr, "I'm yuntan???. %s\n", tag);
	strcat(bitag,tag);	/* bnk_ncn */
	if (tdbm_fetch(ptt_tf,bitag,probstr))
		/* current = P(t1|t0) */
		tbigram=atof((const char*)probstr);
	else 
		/* current = P(ncn|bnk)=0.01 */
		tbigram=PCONSTANT;

	/* P(t1) Ȯ  : interpolation ϱ Ͽ */
	if (tdbm_fetch(ptt_tf,tag,probstr))
		/* current = P(t1|t0) */
		tunigram=atof((const char*)probstr);
	else 
		/* current = P(ncn|bnk)=0.01 */
		tunigram=PCONSTANT;

	/* P(w|t) Ȯ  */
	if (tdbm_fetch(pwt_tf,morphtag,probstr))
		/* current *= P(w|t1) */
		lexicon=atof((const char*)probstr);
	else lexicon= PCONSTANT;

	/*                              
	 *  Ȯ = P(w|t1) * P(t1|t0)
	 *                               Lambda1       Lambda2
	 *          ~= P(w|t1) *(P(t1|t0)       * P(t1)
	 *          (, Lambda1 + Lambda2 = 1) 
	 */
	current= lexicon + Lambda1*tbigram + Lambda2*tunigram;

	strcpy(oldtag,tag);

	while(tmp)
		{
		tmp=front_token(morphtag,tmp,'+');
		get_tag(morphtag,tag);

		/* P(t_i|t_i-1) Ȯ(bigram)  */
		strcpy(bitag,oldtag);
		strcat(bitag,"_");
		strcat(bitag,tag);	/* bnk_ncn */

		if (tdbm_fetch(ptt_tf,bitag,probstr))
			tbigram=atof((const char*)probstr);
		else 
			/* current = P(ncn|bnk)=0.01 */
			tbigram=PCONSTANT;

		/* P(ti) Ȯ  : interpolation ϱ Ͽ */
		if (tdbm_fetch(ptt_tf,tag,probstr))
			/* current = P(t1|t0) */
			tunigram=atof((const char*)probstr);
		else 
			tunigram=PCONSTANT;

		/* P(w|t) Ȯ  */
		if (tdbm_fetch(pwt_tf,morphtag,probstr))
			/* current *= P(w|t) */
			lexicon=atof((const char*)probstr);
		else
			lexicon=PCONSTANT; 
		current+= lexicon + Lambda1*tbigram + Lambda2*tunigram;

		strcpy(oldtag,tag);
		}
}


